#ifndef AMR_AGGREGATOR_H
#define AMR_AGGREGATOR_H


//ids for timed function callbacks
enum {
    BLINK_LED_TIMER_INDEX,
    SEND_ADVERT_TIMER_INDEX,
    REQUEST_METER_HISTORY
};

//------------------------------------------------------------------------------
//Due to shared memory on the host processor, the aggregator is able to maintain
//interaction with up to 250 meters, this number must be less than
//EMBER_HOST_BINDING_TABLE_SIZE indicated in host-api.h
#define MAX_METERS 250

//COMMON DEFS
#define MULTICAST_BINDING_INDEX MAX_METERS

//Aggregator Functions
//void registerMeterWithAggregator(int8u *contents);
//void sendAdvertisement(int8u timerId, int32u param);
int8u findAvailableBinding(int8u *remoteEui64);
//void requestMeterHistory(int8u timerId, int32u param);
void createMulticastBinding(int8u index);
//EmberStatus transmitAmrMessage(int8u bindingIndex, int8u *message, int8u length);
int8u getBindingTableSize(void);
void toggleBlinker(int8u timerId, int32u param);


//Aggregator Commands
//void statusCommand(EmberCommandState *state);
void printEui64(EmberEUI64 eui64);
//void setChannelCommand(EmberCommandState *state);
//void setPowerCommand(EmberCommandState *state);
//void printBindingTable(EmberCommandState *state);
//void helpCommand(EmberCommandState *state);
//void setAdvertisementPeriodCommand(EmberCommandState *state);
//void sendEmptyDatagram(EmberCommandState *state);
//void sendDataRequestCommand(EmberCommandState *state);
//void sendHistoryRequestCommand(EmberCommandState *state);
//void setLedBlink(EmberCommandState *state);
void quit(EmberCommandState *state);
//void showMetersCommand(EmberCommandState *state);

void commandErrorHandler(int8u errorCode);

//int8u VersionNumber[] = "1.08B3";  Moved to 2.00R as now has MiniGateway specific code in it
int8u VersionNumber[] = "2.00R";

#endif //AMR_AGGREGATOR_H


