/**
   @File: binding-table.h
   @brief: Binding table utility functions declaration. 
   @Author(s): Guohui Liu, guohui@ember.com
 
   This Ember Host API library is subject to the Ember corporation
   Development Kit Software License Agreement delivered with this file to
   licensee.
 * Copyright 2004 by Ember Corporation. All rights reserved.                *80*
 */

// Finds the binding index for the incoming datagram message.
int8u emFindIncomingDatagramBinding(EmberNodeId node,
				    int8u localTerminal,
				    int8u remoteTerminal);

// Finds the binding index for the incoming multicast message.
int8u emFindMulticastBinding(int8u start, int16u multicastId);

// Finds the connection index for the given nodeId.
int8u emFindNodeConnectionIndex(EmberNodeId node);

// Finds the binding whose local terminal is the same as the given terminal.
EmberStatus emFindUniqueTerminalBindingIndex(EmberTerminal terminal,
                                             int8u *index);

