/**
   @File: rnap-master.h
   @brief: Declaration of functions used in host node communications.
   @author: Guohui Liu, guohui@ember.com
 
   This Ember Host API library is subject to the Ember corporation
   Development Kit Software License Agreement delivered with this file to
   licensee.
 * Copyright 2004 by Ember Corporation. All rights reserved.                *80*
 */

#ifndef RNAP_MASTER_H
#define RNAP_MASTER_H

#define RNAP_PACKET_OVERHEAD 3

//Initializes a connection to stdio
int8u emMasterConnectStdIO(void);

//Initializes a socket connection
int8u emMasterConnectSocket(int8u *hostName, int16u port);

// Initializes the serial connection.
int8u emMasterConnectSerial(int8u *serialPort);

// Formats the data and puts it into the queue 
// or writes to the descriptor opened for host node communication.
EmberStatus emMasterWrite(int8u *userData, int8u userlength,
				int8u *systemData, int8u systemLength);

// Writes the buffer contents to the descriptor opened for 
// host node communication.
EmberStatus emMasterReallyWrite(EmberMessageBuffer buf);

//write an rnap message out thru a file descriptor
int writeIO(int fd, int8u *data, int8u length);

//build up an rnap message coming in
void buildRnapRxLine(int8u b);

#endif


