/*
This file contains the code to handle incomming data packets from a device
*/


//-----------------------------------------------------
void PrintData_file(int8u Sensor); //debug stuff only
//-----------------------------------------------------

int8u CheckCmdMsg_Result;	
boolean TaskFirmwareTimer = FALSE;
boolean Duplicate = FALSE;



void IncommingSensorData(int8u *contents);
boolean SendCmds(int8u *SerialNum, int8u *OutgoingCmd, int8u *CmdStore);
void DataPacket1(int8u *contents, int8u Device, int8u type);
void DataPacket2(int8u *contents, int8u Device, int8u type);
void DataPacket3(int8u *contents, int8u Device, int8u type);
void DataPacket4(int8u *contents, int8u Device, int8u type);
void SendToNick(int8u Device);


void IncommingSensorData(int8u *contents)
{
	EmberBindingTableEntry binding;
	int8u i, Device, ChkCmdResult, Error;
	int8u CmdBuffer[100];
	int8u ReplyBuffer[90];
	boolean SendCmd = FALSE;
	boolean GotFullMb = FALSE;
	EmberStatus status;
	EmberMessageBuffer reply = 0; 
	
	
	//first check to see if this is one of our nodes
    for (i = 0; i < MAX_METERS; i++) 
	{
      emberGetBinding(i, &binding);
      if (MEMCOMPARE(binding.identifier, (contents+1), 8) == 0) 
	  {
		//we should note the senders binding to update the cost and route
		//to the Device.
	    emberNoteSendersBinding(i); 
		break; 
      }
    }
	
	//get eui64 number from packet
	String_Copy(contents, EUI64_START, Cipher_Params_CU.Eui64, 0, SIZE_EUI64);
	//find this sensor in our array
	Device = SearchDeviceArray(SENSOR);
	String_Copy(SensorSNid[Device].SerialNumber, 0, Cipher_Params_CU.SerialNum, 0, SIZE_SNUM);
	
	if(the_time >= SensorSNid[Device].LastPacketRecieved)//if its been longer than 15 sec's since last herd form
	{													  //this transmitter
		SensorSNid[Device].Packet1 = 0;
		SensorSNid[Device].Packet2 = 0;					  //reset all the flags as this must be a new Monster Block
		SensorSNid[Device].Packet3 = 0;
		SensorSNid[Device].Packet4 = 0;
		SensorSNid[Device].RequiredPackets = 0;
		MEMSET(SensorSNid[Device].Data,0,MAX_DATASIZE);  //clear down the data
		//printf("New MB Rx'd\n\r");
	}
	
	SensorSNid[Device].LastPacketRecieved = the_time + DataPacketTimeOut;	  //reset the timout
	
	switch(contents[0])
	{
		case SENSOR_DATAPACKET_START:
			DataPacket1(contents, Device, SENSOR);
			break;
	
		case SENSOR_DATAPACKET_2:
			DataPacket2(contents, Device, SENSOR);
			break;
			
		case SENSOR_DATAPACKET_3:
			DataPacket3(contents, Device, SENSOR);
			break;
			
		case SENSOR_DATAPACKET_4:
			DataPacket4(contents, Device, SENSOR);
			break;
	}
	
	//fprintf(stderr, "\n\r####Recieving Data %i from %s####\n\r",SensorSNid[Device].Data[BLKLEN_LOC],SensorSNid[Device].SerialNumber);	//debug only
	//fprintf(stderr, "Flags pkt1 %i, Flags pkt2 %i, Flags pkt3 %i, Flags pkt4 %i, Required Pkts %i",SensorSNid[Device].Packet1,SensorSNid[Device].Packet2,SensorSNid[Device].Packet3,SensorSNid[Device].Packet4,SensorSNid[Device].RequiredPackets);

	printf("\n\r####Recieving Data %i from %s####\n\r",SensorSNid[Device].Data[BLKLEN_LOC],SensorSNid[Device].SerialNumber);	//debug only
	printf("Flags pkt1 %i, Flags pkt2 %i, Flags pkt3 %i, Flags pkt4 %i, Required Pkts %i",SensorSNid[Device].Packet1,SensorSNid[Device].Packet2,SensorSNid[Device].Packet3,SensorSNid[Device].Packet4,SensorSNid[Device].RequiredPackets);


	if(!Duplicate)	//should ensure a monster block only gets recieved and passed to nick the once
	{
		if((SensorSNid[Device].RequiredPackets == 1) &&  SensorSNid[Device].Packet1) GotFullMb = TRUE;
		if((SensorSNid[Device].RequiredPackets == 2) && (SensorSNid[Device].Packet1) && (SensorSNid[Device].Packet2)) GotFullMb = TRUE;
		if((SensorSNid[Device].RequiredPackets == 3) && (SensorSNid[Device].Packet1) && (SensorSNid[Device].Packet2) && (SensorSNid[Device].Packet3)) GotFullMb = TRUE;
		if((SensorSNid[Device].RequiredPackets == 4) && (SensorSNid[Device].Packet1) && (SensorSNid[Device].Packet2) && (SensorSNid[Device].Packet3) && (SensorSNid[Device].Packet4)) GotFullMb = TRUE;
	
		//if((SensorSNid[Device].Packet1+SensorSNid[Device].Packet2+SensorSNid[Device].Packet3+SensorSNid[Device].Packet4) == SensorSNid[Device].RequiredPackets)
		if(GotFullMb)
		{
			//dump that data to nick
			//fprintf(stderr, "\n\r####Recieved Monster Block of length %i from %s####\n\r",SensorSNid[Device].Data[BLKLEN_LOC],SensorSNid[Device].SerialNumber);	//debug only
			printf("\n\r####Recieved Monster Block of length %i from %s####\n\r",SensorSNid[Device].Data[BLKLEN_LOC],SensorSNid[Device].SerialNumber);	//debug only
			SensorSNid[Device].GotMonsterBlock = TRUE;
			SensorSNid[Device].Packet1 = 0;
			SensorSNid[Device].Packet2 = 0;
			SensorSNid[Device].Packet3 = 0;
			SensorSNid[Device].Packet4 = 0;
			SensorSNid[Device].RequiredPackets = 0;
			//this is where we will ack the data packet and look for cmds from nick to the Sensor
			//Send data to Nick
			Error = DoRxCmd(SensorSNid[Device].SerialNumber, SensorSNid[Device].Data);
			if(Error != NOERROR) 
			{
				Error_Stop("ERROR RETURNED FROM DoRxCmd() **CODE", Error, SensorSNid[Device].SerialNumber);
				fprintf(stderr, "Data Save Error\n\r");
			}
			else
			{
				SensorSNid[Device].GotMonsterBlock = FALSE;//MEMSET(SensorSNid[Device].Data,0,MAX_DATASIZE);  //clear down the data
			}
			//status = emberGetLastHopLqi(SensorSNid[Device].Lqi);
			//fprintf(stderr, "LQI is %i\n\r", SensorSNid[Device].Lqi);	//would pass to nick here
			//Check if the Transmitter is due to be removed 
			if(SensorSNid[Device].Remove){
					fprintf(stderr, "Sending Remove\n\r");
					ReplyBuffer[0] = CU_REMOVE;
					MEMCOPY(&ReplyBuffer[1], SensorSNid[Device].Eui64number, EUI_LEN);	//add dest eui address need to find it later em msg sent
					ReplyBuffer[9] = SENSOR;
					reply = emberFillLinkedBuffers(ReplyBuffer, 10);
					status = emberSendDatagram(SensorSNid[Device].BindingTableIndex, reply);
					emberReleaseMessageBuffer(reply);
					return;
			}
			else
			{
				SendCmd = SendCmds(SensorSNid[Device].SerialNumber, ReplyBuffer, CmdBuffer);
			}	
		}
	}
	else
	{
		Duplicate = FALSE;
	}
	
	
	//send the cmd back to the transmitter
	if(SendCmd){
			reply = emberFillLinkedBuffers(ReplyBuffer, (CmdBuffer[0] + 1) +1); //1 is My overheads MSG_TYPE
			status = emberSendReply(reply);
			emberReleaseMessageBuffer(reply);
	}
}

//this will ask nick if there are any cmds for Nigel and return the cmd, this also ensures that whilst downloading
//firmware or a task the CU will only deal with one transmitter at a time (i may change this for tasks to x number of transmitters)
boolean SendCmds(int8u *SerialNum, int8u *OutgoingCmd, int8u *CmdStore)//for SENSOR's only
{
	int8u ChkCmdResult;
	unsigned short int Cmd_ID;
		
	ChkCmdResult = AnyCmdsFor(SerialNum, CmdStore);
	if(ChkCmdResult == ERROR) Error_Stop("ERROR RETURNED FROM AnyCmdsFor() **CODE", ChkCmdResult, SerialNum);
	
	fprintf(stderr, "ChkCmdResult is 0x%X\n\r",ChkCmdResult);
	if(ChkCmdResult == YES){
		//New cmd id is two bytes now
		//CmdStore[3]//MSB
		//CmdStore[4]//LSB
		Cmd_ID = CmdStore[4] + (CmdStore[3]<<8);
		
		fprintf(stderr, "Sending Cmds\n\r");
		
		if(!HandlingTransmitter){
			
			switch(Cmd_ID)	//indicates start of a big download
			{
				case C_NEWTASK:
				case C_ER_PGM :
					HandlingTransmitter = TRUE;
					//store the serial number
					MEMCOPY(CurrentTransmitter, SerialNum, SIZE_SNUM);
					TaskFirmwareTimer = TRUE;		//timer to ensure it doesn't get locked up
					CheckTaskFirmTimeOut = the_time + TaskFirmTimeOutPeriod; //set up the timer 
					fprintf(stderr, "Sending first Cmd\n\r");
					break;			
			}
			OutgoingCmd[0] = NODE_INCOMMING_CMD;
			MEMCOPY(&OutgoingCmd[1], CmdStore, CmdStore[0] + 1);
			return (TRUE);
		}
		else
		{	//if we are dealing with a transmitter at the moment
			if(String_Compare(SerialNum, 0, CurrentTransmitter, 0, SIZE_SNUM))//is it this one??
			{
				switch(Cmd_ID)	//check to see if this is the last cmd for this transmitter
				{
					//case C_DONE_NEW_TASK:
					case C_BOOTLD/*C_DONE_FLASHWR*/:
					case C_DONE:
					HandlingTransmitter = FALSE;
					//reset the serial number
					MEMSET(CurrentTransmitter, 0, SIZE_SNUM);
					TaskFirmwareTimer = FALSE;		//timer to ensure it doesn't get locked up
					fprintf(stderr, "Sending last Cmd\n\r");
					break;			
				}
				OutgoingCmd[0] = NODE_INCOMMING_CMD;
				MEMCOPY(&OutgoingCmd[1], CmdStore, CmdStore[0] + 1);
				fprintf(stderr, "Sending other Cmds\n\r");
				return (TRUE);
			}
			else//means i have cmds for this transmitter but it will have to wait until i finish with the current device
			{
				//this is where i will lock out other transmitters
				OutgoingCmd[0] = NODE_CMD_WAITING;
				MEMSET(CmdStore, 0, 4);	//just to make sure there is nothing to send
				return (TRUE);
			}
		}
	}
	else return (FALSE);//there are no cmds for this transmitter
	
}

void DataPacket1(int8u *contents, int8u Device, int8u type)
{
	int8u DataSize = 0;
	//got the start of a new packet so will clear down old flags cant do this here might not get this packet first
	//SensorSNid[Device].Packet1 = 0;
	//SensorSNid[Device].Packet2 = 0;
	//SensorSNid[Device].Packet3 = 0;
	//SensorSNid[Device].Packet4 = 0;
	//SensorSNid[Device].RequiredPackets = 0;
	if(SensorSNid[Device].GotMonsterBlock){
		Error_Stop("ERROR RETURNED FROM DataPacket1() Rx'd Start Data Packet too soon",1, SensorSNid[Device].SerialNumber);
	}
	
		
	switch(type)
	{
	
		case SENSOR:
			if(String_Compare(contents, DATAPKT1STRT_LOC, SensorSNid[Device].Data, PKT1START, PKT1_DATASIZE))
			//if(MEMCOMPARE((contents + DATAPKT1STRT_LOC), (SensorSNid[Device].Data + PKT1START), PKT1_DATASIZE) == 0) //means a match
			{
				printf("\n\rDuplicate Packet Ignor 1\n\r");		//debug only
				Duplicate = TRUE;
			}
			else
			{
				DataSize = contents[BLOCK_SIZE_LOC];
				if(DataSize<LESSTHN1PKT)		SensorSNid[Device].RequiredPackets = 1;
				if(DataSize>MORETHN1PKT)		SensorSNid[Device].RequiredPackets = 2;
				if(DataSize>MORETHN2PKT)		SensorSNid[Device].RequiredPackets = 3;
				if(DataSize>MORETHN3PKT)		SensorSNid[Device].RequiredPackets = 4;
				SensorSNid[Device].Data[BLKLEN_LOC] = DataSize;
				MEMCOPY((SensorSNid[Device].Data + PKT1START), (contents + DATAPKT1STRT_LOC), PKT1_DATASIZE);
				SensorSNid[Device].Packet1 = 1;
				//fprintf(stderr, "Packets required is %i\n\r",SensorSNid[Device].RequiredPackets);		//debug only
				printf("\n\rPackets required is %i\n\r",SensorSNid[Device].RequiredPackets);		//debug only
			}
			break;
	
		case MOBILE:
			DataSize = contents[BLOCK_SIZE_LOC];
			if(DataSize<LESSTHN1PKT)		MobileSNid[Device].RequiredPackets = 1;
			if(DataSize<MORETHN1PKT)		MobileSNid[Device].RequiredPackets = 2;
			if(DataSize<MORETHN2PKT)		MobileSNid[Device].RequiredPackets = 3;
			if(DataSize>MORETHN3PKT)		MobileSNid[Device].RequiredPackets = 4;
			MobileSNid[Device].Data[BLKLEN_LOC] = DataSize;
			MEMCOPY((MobileSNid[Device].Data + PKT1START), (contents + DATAPKT1STRT_LOC), PKT1_DATASIZE);
			MobileSNid[Device].Packet1 = 1;
			break;
			
		case HANDHELD:
			DataSize = contents[BLOCK_SIZE_LOC];
			if(DataSize<LESSTHN1PKT)		HandheldSNid[Device].RequiredPackets = 1;
			if(DataSize<MORETHN1PKT)		HandheldSNid[Device].RequiredPackets = 2;
			if(DataSize<MORETHN2PKT)		HandheldSNid[Device].RequiredPackets = 3;
			if(DataSize>MORETHN3PKT)		HandheldSNid[Device].RequiredPackets = 4;
			HandheldSNid[Device].Data[BLKLEN_LOC] = DataSize;
			MEMCOPY((HandheldSNid[Device].Data + PKT1START), (contents + DATAPKT1STRT_LOC), PKT1_DATASIZE);
			HandheldSNid[Device].Packet1 = 1;
			break;
	
	}

}


void DataPacket2(int8u *contents, int8u Device, int8u type)
{
	
	switch(type)
	{
	
		case SENSOR:
			if(String_Compare(contents, DATASTRT_LOC, SensorSNid[Device].Data, PKT2START, PKT2_DATASIZE))
			//if(MEMCOMPARE((contents + DATASTRT_LOC), (SensorSNid[Device].Data + PKT2START), PKT2_DATASIZE) == 0) //means a match
			{
				printf("\n\rDuplicate Packet Ignor 2\n\r");		//debug only
				Duplicate = TRUE;
			}
			else
			{
				MEMCOPY((SensorSNid[Device].Data + PKT2START), (contents + DATASTRT_LOC), PKT2_DATASIZE);
				SensorSNid[Device].Packet2 = 1;
				//fprintf(stderr, "Got Pack 2\n\r");		//debug only
				printf("\n\rGot Pack 2\n\r");		//debug only
			}
			break;
	
		case MOBILE:
			MEMCOPY((MobileSNid[Device].Data + PKT2START), (contents + DATASTRT_LOC), PKT2_DATASIZE);
			MobileSNid[Device].Packet2 = 1;
			break;
			
		case HANDHELD:
			MEMCOPY((HandheldSNid[Device].Data + PKT2START), (contents + DATASTRT_LOC), PKT2_DATASIZE);
			HandheldSNid[Device].Packet2 = 1;
			break;
	
	}

}

void DataPacket3(int8u *contents, int8u Device, int8u type)
{
	
	switch(type)
	{
	
		case SENSOR:
			if(String_Compare(contents, DATASTRT_LOC, SensorSNid[Device].Data, PKT3START, PKT3_DATASIZE))
			//if(MEMCOMPARE((contents + DATASTRT_LOC), (SensorSNid[Device].Data + PKT3START), PKT3_DATASIZE) == 0) //means a match
			{
				printf("\n\rDuplicate Packet Ignor 3\n\r");		//debug only
				Duplicate = TRUE;
			}
			else
			{
				MEMCOPY((SensorSNid[Device].Data + PKT3START), (contents + DATASTRT_LOC), PKT3_DATASIZE);
				SensorSNid[Device].Packet3 = 1;
				//fprintf(stderr, "Got Pack 3\n\r");		//debug only
				printf("\n\rGot Pack 3\n\r");		//debug only
			}
			break;
	
		case MOBILE:
			MEMCOPY((MobileSNid[Device].Data + PKT3START), (contents + DATASTRT_LOC), PKT3_DATASIZE);
			MobileSNid[Device].Packet3 = 1;
			break;
			
		case HANDHELD:
			MEMCOPY((HandheldSNid[Device].Data + PKT3START), (contents + DATASTRT_LOC), PKT3_DATASIZE);
			HandheldSNid[Device].Packet3 = 1;
			break;
	
	}

}

void DataPacket4(int8u *contents, int8u Device, int8u type)
{
	
	switch(type)
	{
	
		case SENSOR:
			if(String_Compare(contents, DATASTRT_LOC, SensorSNid[Device].Data, PKT4START, PKT4_DATASIZE))
			//if(MEMCOMPARE((contents + DATASTRT_LOC), (SensorSNid[Device].Data + PKT4START), PKT4_DATASIZE) == 0) //means a match
			{
				printf("\n\rDuplicate Packet Ignor 4\n\r");		//debug only
				Duplicate = TRUE;
			}
			else
			{
				MEMCOPY((SensorSNid[Device].Data + PKT4START), (contents + DATASTRT_LOC), PKT4_DATASIZE);
				SensorSNid[Device].Packet4 = 1;
				//fprintf(stderr, "Got Pack 4\n\r");		//debug only
				printf("\n\rGot Pack 4\n\r");		//debug only
			}
			break;
	
		case MOBILE:
			MEMCOPY((MobileSNid[Device].Data + PKT4START), (contents + DATASTRT_LOC), PKT4_DATASIZE);
			MobileSNid[Device].Packet4 = 1;
			break;
			
		case HANDHELD:
			MEMCOPY((HandheldSNid[Device].Data + PKT4START), (contents + DATASTRT_LOC), PKT4_DATASIZE);
			HandheldSNid[Device].Packet4 = 1;
			break;
	
	}

}


void SendToNick(int8u Device)
{
	int8u Error = 0;
	SensorSNid[Device].Packet1 = 0;
	SensorSNid[Device].Packet2 = 0;
	SensorSNid[Device].Packet3 = 0;
	SensorSNid[Device].Packet4 = 0;
	SensorSNid[Device].RequiredPackets = 0;
	
	//Send data to Nick
	Error = DoRxCmd(SensorSNid[Device].SerialNumber, SensorSNid[Device].Data);
	if(Error != NOERROR) 
	{
		Error_Stop("ERROR RETURNED FROM DoRxCmd() **CODE", Error, SensorSNid[Device].SerialNumber);
		fprintf(stderr, "Data Save Error\n\r");
	}
	//else
	//{
		//MEMSET(SensorSNid[Device].Data,0,MAX_DATASIZE);  //clear down the data
	//}
	SensorSNid[Device].GotMonsterBlock = FALSE;
}


void PrintData_file(int8u Device)		//debug stuff only
{
	FILE *info;
	int8u i;
	
	info = fopen("/home/ember/Ember/Data_file.txt" , "ab+");
	fprintf(info,"Serial Num is:%s\r\n",SensorSNid[Device].SerialNumber);
	
	fprintf(info,"Packet size is (decimal): %d\r\n",SensorSNid[Device].Data[0]);
	
	for(i=0;i<(SensorSNid[Device].Data[0]);i++)
	{
		fprintf(info,"%02X,",SensorSNid[Device].Data[i]);
	}
	
	fprintf(info,"\n\r");	
	
	fclose(info);
}




