/**
 * File: cipher-aggregator-cmds.c
 * Description: aggregator commands
 *
 * Copyright 2004 by Ember Corporation. All rights reserved.                *80*
 */


static void showMeters(EmberCommandState *state);
void version(EmberCommandState *state) ;

//commands used by the command interpreter
EmberCommandEntry commands[] = {
  {'v',   "ver",version,"", "application version number"},
  {'q',   "quit",quit,"", "quit the application"},
  {'m',   "printmeters",showMeters,"", "print a list of meters" },
  { 0, NULL, NULL, NULL, NULL } // NULL action makes this a terminator
};


EmberMessageBuffer arguments[4];

EmberCommandState commandState =
  {
    commands,
    commandErrorHandler,
    arguments,
    4,                    // maximum command arguments
    10                    // integer base
  };

//exit the host application
void version(EmberCommandState *state) 
{
  printf("\n\rCollection Unit Host Software Version 0.53B\n\r");
}


static void showMeters(EmberCommandState *state)
{
  int i=0;
  
  EmberStatus status;
  EmberBindingTableEntry result;
    
  do
  {
	fprintf(stderr, "Comark S/N %s Table Location %d Node Model: %s EUI64 Num is ",SensorSNid[i].SerialNumber , i, SensorSNid[i].ModelString);
	status = emberGetBinding(i, &result);
    
	printEui64(SensorSNid[i].Eui64number);
    fprintf(stderr, " \n");
    i++; 
  }
  while(i<30);
}

//----------------------------------------------------------------
void commandErrorHandler(int8u errorCode)
{
  fprintf(stderr, "Error: %p\r\n",
           emberCommandErrorNames[errorCode]);  
}


//a utility for printing the EUI64
void printEui64(EmberEUI64 eui64)
{
  fprintf(stderr, "%X%X%X%X%X%X%X%X",
           eui64[0], eui64[1], eui64[2], eui64[3],
           eui64[4], eui64[5], eui64[6], eui64[7]);
}


//exit the host application
void quit(EmberCommandState *state) 
{
  assert(FALSE);
}


