#ifndef AMR_METER_H
#define AMR_METER_H

#define AGGREGATOR_DEFAULT 0xff

#define MAXIMUM_AGGREGATORS 1   //changed for cipher
#define ACCEPTABLEFAILURES  4





//the following is sleep mode stuff-----------------------------------
//--------------------------------------------------------------------
void GoToSleep(void)
{
  INTERRUPTS_OFF();
  //disable watchdog
  WDTCR = BIT(WDCE) + BIT(WDE); 
  WDTCR = 0;
  EICRA |= 1<<ISC21;   //set high        set external int (RXD) for low going
  EICRA &=~1<<ISC20;   //set low 
  EIMSK |= 1<<INT2;
  adcSleep();  //turn off adc
  INTERRUPTS_ON();
  microSleep(SLEEPMODE_POWERDOWN); //SLEEPMODE_IDLE or SLEEPMODE_RESERVED or SLEEPMODE_POWERDOWN or SLEEPMODE_POWERSAVE
  INTERRUPTS_OFF();
  //enable watchdog
  WDTCR = BIT(WDCE) + BIT(WDE);
  WDTCR = BIT(WDE) + BIT(WDP2) + BIT(WDP1) + BIT(WDP0);   // 2secs
  INTERRUPTS_ON();
}


//--------------------------------------------------------------------
//--------------------------------------------------------------------



enum {		//devices will be catagorized into the following classes
  //Most transmitters will use this class Eg the standard transmitters supplied with the system
  SENSOR,
  //Mobile devices could be transport stylee
  MOBILE,
  //Auditor RF etc
  HANDHELD,
};

typedef struct {		        //this will not be used for the CU look in Device-management.h
        int8u         Model;            //for nick
        int8u         DeviceType;       //SENSOR,MOBILE,HANDHELD
	int8u         bMesher;	        //Whether a constant mesher
	int8u         SerialNum[11];
	int8u         ModelStr[12];
	int8u         FirmwareStr[7];   //Nigels
	int8u         RFFirmwareStr[7]; //Mine
	} commission_t;

commission_t Cipher_Params;


//ids for timed function callbacks
enum {  
  BLINK_LED_TIMER_INDEX,
  SEND_ANNOUNCE_TIMER_INDEX,
  SEND_HISTORY_TIMER_INDEX,
  SEND_REPORT_TIMER_INDEX,
  START_REPORTING_TIMER_INDEX
};

//APP FUNCTIONS
void createMulticastBinding(int8u index);
void toggleBlinker(int8u timerId, int32u param);
void CheckSumWriteBinaryDelimiter (int8u *data, int8u bin_len, int8u *builtdata);
int8u CheckSumVerify (int8u *data, int8u bin_len);
//COMMANDS

void bootloadCommand(EmberCommandState *state);
void commandErrorHandler(int8u errorCode);
void packetcmd(EmberCommandState *state);
void R_Status(EmberCommandState *state);
void GetCipherParameters(EmberCommandState *state);
void TxDatacmd(EmberCommandState *state);
void D_Sleep(EmberCommandState *state);
void SendCmdtoNigel(EmberCommandState *state);
void CmdPacket(EmberCommandState *state);
void FindCu(EmberCommandState *state);
void test(EmberCommandState *state);

#endif //AMR_METER_H
