
#define PACKET2             2
#define PACKET3             3
#define PACKET4             4

#define PACKET1SIZE         67
#define PACKET2SIZE         68
#define PACKET3SIZE         PACKET2SIZE
#define PACKET4SIZE         PACKET2SIZE

#define PACKET1START        1
#define PACKET2START        68
#define PACKET3START        136
#define PACKET4START        204

#define PACKET1HEADER       10              //10 = msg type + eui64 + Block size
#define PACKET2HEADER       9               //9 = msg type + eui64,
#define PACKET3HEADER       PACKET2HEADER   //9 = msg type + eui64,
#define PACKET4HEADER       PACKET2HEADER   //9 = msg type + eui64,

//#define PACKETRETRYLIMIT    1     //was 2 will now let stack do it have now hacked it to 1 so will go through same process as 
                                  //before but without actually sending the packet to the stack
boolean GotDataPacketACK = FALSE;

void CreatePacket1(int8u BytesToSend, int8u BlockLength, int8u DevType);
void CreatePacket(int8u BytesToSend, int8u PacketNumber, int8u DevType);
void PacketsStatus(void);
void InitPacketRetryStuct(int8u BlockLength);
void InitStatusSruct(void);

typedef struct {
      boolean Packet1Fail:1;
      boolean Packet2Fail:1;
      boolean Packet3Fail:1;
      boolean Packet4Fail:1;
      boolean Packet1Rx:1;
      boolean Packet2Rx:1;
      boolean Packet3Rx:1;
      boolean Packet4Rx:1;
      boolean AllPacketsGone:1;
      int8u   PacketsCreated;
      int8u   Packet1size;
      int8u   Packet2size;
      int8u   Packet3size;
      int8u   Packet4size;
      //int8u   Packet1RetryCount;
      //int8u   Packet2RetryCount;
      //int8u   Packet3RetryCount;
      int8u   DataBlockSize;
} MessageRetry_S;

MessageRetry_S MessageResults;

typedef struct {
      boolean bCommissioned:1;	//Indicates that Radio Module has valid Commision Data (SerialNum etc)
      boolean bConnected:1;		//Indicates that Radio Module is bound to a CU
      boolean bBusy:1;			//Indicates that Radio Module is busy transmitting a monster_block
      boolean bDelivered:1;
      boolean bDeliveryFail:1;
      boolean bMesher:1;			//Whether a constant mesher
      boolean bCuRecord:1;		//Indicates that Radio Module has received a record from the CU. (Please collect it)
      boolean bShortIdle:1;		//
} RadioStatus_S;

RadioStatus_S RStatus;


void InitPacketRetryStuct(int8u BlockLength)    //this is called at the beginning of a monsterblock send
{
  MessageResults.AllPacketsGone = FALSE;
  MessageResults.Packet1Rx = FALSE;
  MessageResults.Packet2Rx = FALSE;
  MessageResults.Packet3Rx = FALSE;
  MessageResults.Packet4Rx = FALSE;
  MessageResults.Packet1Fail = FALSE;
  MessageResults.Packet2Fail = FALSE;
  MessageResults.Packet3Fail = FALSE; 
  MessageResults.Packet4Fail = FALSE; 
  MessageResults.Packet1size = 0;   //this is for any retry's and confirmation of send
  MessageResults.Packet2size = 0;
  MessageResults.Packet3size = 0; 
  MessageResults.Packet4size = 0;
  MessageResults.PacketsCreated = 0;
  //MessageResults.Packet1RetryCount = 0;
  //MessageResults.Packet2RetryCount = 0;
  //MessageResults.Packet3RetryCount = 0;
  MessageResults.DataBlockSize = BlockLength; 
  
  //Status Flags for nigel
  RStatus.bBusy = TRUE;           //indicates i have recieved a monster block and am trying to send it
  RStatus.bDelivered = FALSE;     //indicates block delivered
  RStatus.bDeliveryFail = FALSE;  //indicates block failed
}

void InitStatusSruct(void)
{
  RStatus.bCommissioned = FALSE;
  RStatus.bConnected = FALSE;
  RStatus.bBusy = FALSE;
  RStatus.bDelivered = FALSE;
  RStatus.bDeliveryFail = FALSE;
  RStatus.bMesher = FALSE;
  RStatus.bCuRecord = FALSE;
  RStatus.bShortIdle = FALSE;
}




void CreatePacket1(int8u BytesToSend, int8u BlockLength, int8u DevType)
{
  EmberStatus status;
  EmberMessageBuffer buffer = 0;
    
  switch(DevType)
  {
    case SENSOR:    globalBuffer[0] = SENSOR_DATAPACKET_START;   break;
    case MOBILE:    globalBuffer[0] = MOBILE_DATAPACKET_START;   break;
    case HANDHELD:  globalBuffer[0] = HANDHELD_DATAPACKET_START; break;
  }
  MEMCOPY(&(globalBuffer[1]), emberGetEui64(), EUI_LEN);
  globalBuffer[9] = BlockLength;    //monster block size would be MonsterBlock[0]
  
  MEMCOPY(&(globalBuffer[10]), &(MonsterBlock[PACKET1START]), BytesToSend);
  // copy the data into a packet buffer 
  buffer = emberFillLinkedBuffers(globalBuffer, BytesToSend+PACKET1HEADER); //
  // check to make sure a buffer is available
  if (buffer == EMBER_NULL_MESSAGE_BUFFER) 
  {
    //emberSerialGuaranteedPrintf(SERIAL_PORT,"No buffer");
    RStatus.bDeliveryFail = TRUE;
    RStatus.bBusy = FALSE;
    MEMSET(MonsterBlock, 0, MAXBLOCK_SIZE);
    return;
  }
  emberTick();        //very experimental!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  // send the message
  status = emberSendDatagram(CU_BINDING_INDEX, buffer);
  //emberSerialGuaranteedPrintf(SERIAL_PORT,"status is %x\r\n",status);  //debug only
  // done with the packet buffer
  emberTick();        //very experimental!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  MessageResults.PacketsCreated = 1;
  emberReleaseMessageBuffer(buffer);
}


void CreatePacket(int8u BytesToSend, int8u PacketNumber, int8u DevType)
{
  EmberStatus status;
  EmberMessageBuffer buffer = 0;
    
  switch(PacketNumber)
  {
    case PACKET2:
         //globalBuffer[0] = SENSOR_DATAPACKET_2;
         switch(DevType)
         {
            case SENSOR:    globalBuffer[0] = SENSOR_DATAPACKET_2;   break;
            case MOBILE:    globalBuffer[0] = MOBILE_DATAPACKET_2;   break;
            case HANDHELD:  globalBuffer[0] = HANDHELD_DATAPACKET_2; break;
         }
         MEMCOPY(&(globalBuffer[1]), emberGetEui64(), EUI_LEN);
         MEMCOPY(&(globalBuffer[DATA_START_INDEX]), &(MonsterBlock[PACKET2START]), BytesToSend);
         // copy the data into a packet buffer 
         buffer = emberFillLinkedBuffers(globalBuffer, BytesToSend+PACKET2HEADER);  
         MessageResults.PacketsCreated = 2;
         break;
    
    case PACKET3:
         //globalBuffer[0] = SENSOR_DATAPACKET_3;
         switch(DevType)
         {
            case SENSOR:    globalBuffer[0] = SENSOR_DATAPACKET_3;   break;
            case MOBILE:    globalBuffer[0] = MOBILE_DATAPACKET_3;   break;
            case HANDHELD:  globalBuffer[0] = HANDHELD_DATAPACKET_3; break;
         }
         MEMCOPY(&(globalBuffer[1]), emberGetEui64(), EUI_LEN);
         MEMCOPY(&(globalBuffer[DATA_START_INDEX]), &(MonsterBlock[PACKET3START]), BytesToSend);
         // copy the data into a packet buffer 
         buffer = emberFillLinkedBuffers(globalBuffer, BytesToSend+PACKET3HEADER); //9 = msg type + eui64,
         MessageResults.PacketsCreated = 3;
         break;
         
     case PACKET4:
         //globalBuffer[0] = SENSOR_DATAPACKET_3;
         switch(DevType)
         {
            case SENSOR:    globalBuffer[0] = SENSOR_DATAPACKET_4;   break;
            case MOBILE:    globalBuffer[0] = MOBILE_DATAPACKET_4;   break;
            case HANDHELD:  globalBuffer[0] = HANDHELD_DATAPACKET_4; break;
         }
         MEMCOPY(&(globalBuffer[1]), emberGetEui64(), EUI_LEN);
         MEMCOPY(&(globalBuffer[DATA_START_INDEX]), &(MonsterBlock[PACKET4START]), BytesToSend);
         // copy the data into a packet buffer 
         buffer = emberFillLinkedBuffers(globalBuffer, BytesToSend+PACKET4HEADER); //9 = msg type + eui64,
         MessageResults.PacketsCreated = 4;
         break;    
    
  }
  if (buffer == EMBER_NULL_MESSAGE_BUFFER) 
  {
    //emberSerialGuaranteedPrintf(SERIAL_PORT,"No buffer");
    RStatus.bDeliveryFail = TRUE; //run out of stack buffers so will indicate message failed
    RStatus.bBusy = FALSE;
    MEMSET(MonsterBlock, 0, MAXBLOCK_SIZE);
    return;
  }
  // send the message
  status = emberSendDatagram(CU_BINDING_INDEX, buffer);
  // done with the packet buffer
  emberReleaseMessageBuffer(buffer);
}


void PacketsStatus(void)
{
  int8u PacketsRecievedGood = 0;
  int8u PacketsRecieved = 0;
  int8u PacketsFail = 0;
  //int8u Retrys = 0;         //allowable retries for this block of data
  
  GotDataPacketACK = FALSE;   //cancell the flag
  //so if only 2 packets created total of 4 retries allowable
  //Retrys = MessageResults.PacketsCreated *PACKETRETRYLIMIT;
  //find out how many retries so far
  //RetryCount = MessageResults.Packet1RetryCount + MessageResults.Packet2RetryCount + MessageResults.Packet3RetryCount;
  
  if(!MessageResults.AllPacketsGone)//the retrying stuff--------------------------------------------------------
  {
    //if((MessageResults.Packet1Fail) && (MessageResults.Packet1RetryCount<PACKETRETRYLIMIT)){
    //CreatePacket1(MessageResults.Packet1size, MessageResults.DataBlockSize, Cipher_Params.DeviceType);//will create and send a packet
    //  MessageResults.Packet1RetryCount++;
    //}
    //if((MessageResults.Packet2Fail) && (MessageResults.Packet2RetryCount<PACKETRETRYLIMIT)){
    //CreatePacket(MessageResults.Packet2size, PACKET2, Cipher_Params.DeviceType);                      //will create and send a packet
    //  MessageResults.Packet2RetryCount++;
    //}
    //if((MessageResults.Packet3Fail) && (MessageResults.Packet3RetryCount<PACKETRETRYLIMIT)){
    //CreatePacket(MessageResults.Packet3size, PACKET3, Cipher_Params.DeviceType);                      //will create and send a packet
    //  MessageResults.Packet3RetryCount++;
    //}

    if(MessageResults.Packet1Rx) PacketsRecievedGood++;   //packets that have been ACK'd
    if(MessageResults.Packet2Rx) PacketsRecievedGood++;
    if(MessageResults.Packet3Rx) PacketsRecievedGood++;
    if(MessageResults.Packet4Rx) PacketsRecievedGood++;
    //---------------------------------------------
    if(MessageResults.Packet1Fail) PacketsFail++;         //packets that have been NACK'd
    if(MessageResults.Packet2Fail) PacketsFail++;
    if(MessageResults.Packet3Fail) PacketsFail++;
    if(MessageResults.Packet4Fail) PacketsFail++;
    
    PacketsRecieved = PacketsFail + PacketsRecievedGood;    //checks to see how many packets good or bad have been recieved
    
    if(PacketsRecievedGood == MessageResults.PacketsCreated){
      MessageResults.AllPacketsGone = TRUE;
      //Tell nigel block has gone 
      RStatus.bDelivered = TRUE;      //Nigels information
      RStatus.bBusy = FALSE;
      MEMSET(MonsterBlock, 0, MAXBLOCK_SIZE);
    }
  }//---------------------------------------------------------------------------------------------------------
  
  //have tried but some of the packets have really failed so tell nigel
  if((PacketsRecieved == MessageResults.PacketsCreated) && !MessageResults.AllPacketsGone){
      RStatus.bDeliveryFail = TRUE;     //Nigels information
      RStatus.bBusy = FALSE;
      MEMSET(MonsterBlock, 0, MAXBLOCK_SIZE);
  }
  
  
}





