/*
 * File: amr.h
 * Description: internal declarations for the AMR application
 *
 * Author(s): Richard Kelsey, richard@ember.com
 *            Ezra Hale, ezra@ember.com
 *
 * Copyright 2004 by Ember Corporation. All rights reserved.                *80*
 */



// For identifying ourselves over the serial port.
extern PGM_NO_CONST PGM_P applicationString;

void initializeEmberStack(void);
//void createMulticastBinding(int8u index);
boolean findEui64Binding(EmberEUI64 key, int8u *index);
void toggleBlinker(void);
//extern EventControlQS blinkEvent;
void initialize(EmberCommandState *commandState);
void run(EmberCommandState *commandState, void (* appEvent)(void));

//----------------------------------------------------------------
// Standard commands.


void printEui64(EmberEUI64 eui64);

void commandErrorHandler(int8u errorCode);

//----------------------------------------------------------------
     
#if DEBUG_ON
#define ifDebug(stuff) do { stuff } while 0
#else
#define ifDebug(stuff)
#endif

#define elapsedTime(oldTime, newTime)      \

// True if NOW is after LIMIT.   Handles wraparound.
#define timeHasPast(now, limit)   \
 (((int16u) ((int16u)(now) - (int16u)(limit))) <= ((0xFFFF + 1) / 2))







