#ifndef AMR_METER_H
#define AMR_METER_H

// We put a command and sequence number in each report.
#define minimumReportSize (2)
#define maximumReportSize (64)

#define AGGREGATOR_DEFAULT 0xff

#define MAXIMUM_AGGREGATORS 3


//ids for timed function callbacks
enum {  
  BLINK_LED_TIMER_INDEX,
  SEND_ANNOUNCE_TIMER_INDEX,
  SEND_HISTORY_TIMER_INDEX,
  SEND_REPORT_TIMER_INDEX,
  START_REPORTING_TIMER_INDEX
};

//APP FUNCTIONS
void ageAggregators(int8u current);
void considerAggregatorAdvertisement(int8u *contents);
void announcePresence(void);
void startReporting(int8u timerId, int32u param);
void sendAnnounce(int8u timerId, int32u param);
void sendReport(int8u timerId, int32u param);
void sendDataReply(void);
void sendHistory(int8u timerId, int32u param);
void createMulticastBinding(int8u index);
EmberStatus transmitAmrMessage(int8u bindingIndex, int8u *message, int8u length);
boolean findEui64Binding(EmberEUI64 key, int8u *index);
int8u getBindingTableSize(void);
void toggleBlinker(int8u timerId, int32u param);


//COMMANDS
void statusCommand(EmberCommandState *state);
void printEui64(EmberEUI64 eui64);
void setChannelCommand(EmberCommandState *state);
void setPowerCommand(EmberCommandState *state);
void printBindingTable(EmberCommandState *state);
void helpCommand(EmberCommandState *state);
void bootloadCommand(EmberCommandState *state);
void setReportPeriodCommand(EmberCommandState *state);
void setReportSizeCommand(EmberCommandState *state);
void infoCommand(EmberCommandState *state);
void printAggregatorsCommand(EmberCommandState *state);
void sendReportCommand(EmberCommandState *state);
void commandErrorHandler(int8u errorCode);


#endif //AMR_METER_H
