/*
 * File: rnap-static-memory.h
 * Description: Application configurable memory allocations for RNAP
 *
 * Copyright 2004 by Ember Corporation. All rights reserved.                *80*
 */

#ifdef __EMBER_RNAP_STATIC_MEM_H__ 
  #error rnap-static-memory.h should not be included more than once
#endif
#define __EMBER_RNAP_STATIC_MEM_H__

// This file should be included by the main source file of an application in
//   order to allocate memory required by RNAP.  It should only be included
//   a single time for any given application
// This file allows adjusting memory allocations as required by a particular
//   application's needs.
// #########################################################
// # Application developers should not modify any portion  #
// #  of this file.  Doing so may lead to mysterious bugs. #
// # Allocations should be adjusted only with the macros.  #
// #########################################################

// *****************************************
// The following macros are used in this file.
// *****************************************
// EMBER_PACKET_BUFFER_COUNT
// EMBER_BINDING_TABLE_SIZE

// *****************************************
// Memory Allocations & declarations
// *****************************************

int8u emBindingHostIndex[EMBER_BINDING_TABLE_SIZE];
int8u emMessageTokens[EMBER_PACKET_BUFFER_COUNT];
