/*
 * File: ember-static-struct.h
 * Description: Type definitions for customer configurable memory allocations
 * Author(s): Richard Kelsey, kelsey@ember.com
 *
 * Copyright 2004 by Ember Corporation. All rights reserved.                *80*
 */

#ifndef __EMBER_STATIC_STRUCT_H__ 
#define __EMBER_STATIC_STRUCT_H__

// This file is used in conjunction with ember-static-memory.h
//  to provide typedefs for structures allocated there.

// #########################################################
// # Application developers should not modify any portion  #
// #  of this file.  Doing so may lead to mysterious bugs. #
// #########################################################


// Connections

typedef struct {
  int8u data[13];
} EmConnectionData;

// Packets

typedef struct {
  int8u data[8];
} EmPacketData;

// Cost table entries

typedef struct {
  int16u nodeId;                // The destination node.
  int8u cost;                   // Cost to destination.
  int8u ageAndGradientId;	// Low two bits are the age tag, the rest
				// are the id for the gradient.
} EmCostTableEntry;



#endif // #ifndef __EMBER_STATIC_STRUCT_H__ 
