#!/usr/bin/python
# -*- coding: UTF-8 -*-

from bottle import Bottle, request, run, static_file

import login
import firmwareinfo
import fileupload
import report_users
import report_tabrdgs
import api_marvin

app = Bottle()
app.mount('/fwinfo', firmwareinfo.app)
app.mount('/users', report_users.app)
app.mount('/txtabular', report_tabrdgs.app)

@app.route('/login', method='GET')
def do_login_get():
    return login.login_form()
@app.route('/login', method='POST')
def do_login_post():
    return login.login_action()
@app.route('/upload/<filetype>', method='POST')
def do_upload(filetype):
    api_obj = fileupload.upload_file(filetype, request)
    return api_marvin.serve_marvin_dto(api_obj)


@app.route('/war/<filename:re:.*css>')
def send_static(filename):
    return static_file(filename, root='./static/')

@app.route('/war/images/<filename>')
def send_image(filename):
    return static_file(filename, root='./static/')

@app.route('/uploadtest')
def send_upload():
    return static_file('UploadForm.html', root='./static/')


# @route('/txtabular')
# def txtabular():
#     return tabdata.txtabular()

# run(app, host='localhost', port=8080)
# run(app, host='localhost', port=8080, reloader=True)
run(app, host='localhost', port=8080, debug=True)
# run(app, host='localhost', port=8080, reloader=True, debug=True)

