#!/usr/bin/python
# -*- coding: UTF-8 -*-

"""
A File Uploading module dealing with:
1. Transmitter Firmware & RF Module Firmware (filetype : firmware)
2. Gateway Updates (filetype : gateway)
3. Backup Restore Files (filetype : restore)
"""
import os
import api_marvin

filepath_map = {'firmware' : '', 'gateway': '', 'image':'', 'restore':''}
TEMPORARY_PATH = '/tmp/incoming/'

def upload_file(filetype, request):
    if filetype not in filepath_map:
        return api_marvin.build_system_error('Invalid Filetype')

    uploader = request.files.get('uploader')
    #uploader = request.forms.get('uploader')
    if not os.path.exists(TEMPORARY_PATH):
        os.mkdir(TEMPORARY_PATH, 0755)
    uploader.save(TEMPORARY_PATH, overwrite=True)
    return api_marvin.build_system_error(uploader.content_length)
