import os
import sys

os.chdir(os.path.dirname(__file__))

from bottle import Bottle, request, run, static_file, debug
import login
import firmwareinfo
import fileupload
import report_users
import report_tabrdgs
import api_marvin


#def application(environ, start_response):
#    """Inspect the URL and call the appropriate web-service"""
#
#    # I have only one REST URL so lets do it
#    return [readfilebase16.application(environ, start_response)]


app = Bottle()
# debug(True)
app.mount('/fwinfo', firmwareinfo.app)
app.mount('/txtabular', report_tabrdgs.app)
app.mount('/users', report_users.app)

@app.route('/login', method='GET')
def do_login_get():
    return login.login_form()
@app.route('/login', method='POST')
def do_login_post():
    return login.login_action()
@app.route('/upload/<filetype>', method='POST')
def do_upload(filetype):
    api_obj = fileupload.upload_file(filetype, request)
    return api_marvin.serve_marvin_dto(api_obj)

application = app
