#! /usr/bin/python
# -*- coding: UTF-8 -*-

"""This Program attempts to duplicate the functionality of the original
Kantaris c code, rather than a wholesale rewrite.
Hopefully this code will become an excellent base upon which functionality mods
would become trivial

@author: Nigel Winterbottom
"""

from ciphertypes import TxModel, ScaleT, ScaleRH


class TransmitterConfig:
    """The essentials of a Transmitter needed for may Views"""
    sno = ""
    model = TxModel.MDL_PST
    task_no = 0
    period_no = 0
    bIntlEn = False
    bExt1En = False
    bExt2En = False
    bDoorEn = False
    t_scale = ScaleT.SCL_C
    rh_scale = ScaleRH.SCL_RH
    decimals = [0, 0, 0, 0]
    door_avg_interval = 0

