%import datetime

%DATE_STRING_FORMAT = "%d %b %Y %H:%M" # Example: 04 Dec 2013 10:41

<%
def print_restrictions(restrictions):
	seq = []
	for restriction in restrictions:
		seq.append('1') if restriction else seq.append('0')
	end
	return '\n'.join( ("".join(seq[0:8]), "".join(seq[8:16]), "".join(seq[16:24]), "".join(seq[24: ])) )
end
%>

<!doctype html>
<head>
<meta content="text/html; charset=UTF-8" http-equiv="content-type">
<title>Users Report</title>
<link rel="stylesheet" type="text/css" href="/rf500a/Marvin.css" media="all">
<style type="text/css">

h1 {
	text-align: center;
	font-size: 18x;
}

.boxed {
	border-width: 1px;
	border-style: none;
}

</style>
</head>
<html>
<body>
	<div style="width: 100%; text-align: left;">
		<div class = "boxed" style="float: left; width: 20%;">
			<img src="/rf500a/images/logo.png" height="53pt" width="128pt" alt="Comark Logo" border="0">
		</div>
		<div class="boxed" style="float: right; width: 20%; text-align: right"> <p>{{datetime.datetime.now().strftime(DATE_STRING_FORMAT)}}</p>
		</div>
		<div class = "boxed" style="clear:none"> <h1>RF500A Registered Users Report</h1> </div>
		<br>
	</div>
	<div style="clear:both; align:center">
		<table style="border-collapse: collapse; width: 100%;">
			<tbody>
				<tr>
					<td><b></b></td>
					<td></td>
					<td></td>
					<td></td>
					<td><b>Gateway Name:</b></td>
					<td>{{gateway_name}}</td>
				</tr>
				<tr>
					<td><b></b></td>
					<td></td>
					<td></td>
					<td></td>
					<td><b>Gateway Serial No:</b></td>
					<td>{{gateway_sno}}</td>
				</tr>
				<tr>
					<td><b></b></td>
					<td></td>
					<td></td>
					<td></td>
					<td><b>Gateway Software:</b></td>
					<td>{{gateway_vn}}</td>
				</tr>
				<tr>
					<td></td>
					<td></td>
					<td></td>
					<td></td>
					<td></td>
					<td></td>
				</tr>
				<tr>
					<td></td>
					<td></td>
					<td></td>
					<td></td>
					<td></td>
					<td></td>
				</tr>
			</tbody>
		</table>
		<br>

		<!-- TABULAR DATA TABLE HEADER -->
		<table class="tabularData" style="table-layout: fixed; width: 100%;" cellspacing="0">
			<colgroup>
				<col> <col> <col> <col> <col> <col> <col> <col> <col> <col>
			</colgroup>
			<thead>
				<tr>
					<th colspan="1">UserID</th>
					<th colspan="1">Active</th>
					<th colspan="1">UserName</th>
%if show_password:
					<th colspan="1">Password</th>
%end
					<th colspan="1">Expiry Date</th>
					<th colspan="1">Restricted<br>Alarm Groups</th>
					<th colspan="1">Administrator</th>
					<th colspan="1">Tasking</th>
					<th colspan="1">Ack Alarm</th>
					<th colspan="1">Sign Data</th>
				</tr>
			</thead>
		</table>

		<!-- TABULAR DATA TABLE BODY -->
		<table class="tabularData" style="table-layout: fixed; width: 100%;" cellspacing="0">
			<colgroup><col><col><col><col><col><col><col><col><col><col></colgroup>
			<tbody>
				%for user in users:
					<tr class="">
						<td class=""><div tabindex="0" style="outline-style:none;">{{user.user_id}}</div></td>
						<td class=""><div style="outline-style:none;">{{user.bActive}}</div></td>
						<td class=""><div style="outline-style:none;">{{user.username}}</div></td>
%if show_password:
						<td class=""><div style="outline-style:none;">{{user.password}}</div></td>	
%end
						<td class=""><div style="outline-style:none;">{{user.expiredate.strftime("%d %b %Y")}}</div></td>
					<!--<td class=""><div style="outline-style:none;">{{user.restricted_alarmgroups}}</div></td>  -->
						<td class=""><div style="outline-style:none;">{{print_restrictions(user.restricted_alarmgroups)}}</div></td>
						<td class=""><div style="outline-style:none;">{{user.bAdministrator}}</div></td>
						<td class=""><div style="outline-style:none;">{{user.bAllow_set_task}}</div></td>
						<td class=""><div style="outline-style:none;">{{user.bAllow_ack_alarm}}</div></td>
						<td class=""><div style="outline-style:none;">{{user.bAllow_sign_data}}</div></td>
					</tr>
				%end
			<tbody>
		</table>
	<br>
</body>
</html>
